'//Program:         PopUp.Bas
'//Description:     Win95 ALT (Right Click) PopUp
'//Complier:        QBasic4.5 using Qlb.lib
'//Created by:      Steven Castle aka PURE_POWER
'                   Reality Software(c)
'                   RealitySoftware.multiservers.com

'//Extras:          Thx to qbwinfnt. QB Windows Font Maker/Editor
'                   Download this from our home page under files/other/


'//Sub Declarations

DEFINT A-Z
DECLARE SUB PopUp ()
DECLARE SUB MouseDriver (a, B, c, d)
DECLARE SUB fopen (file$, file%)
DECLARE SUB fprint (text$, textx%, texty%, colour%, file%)


'//Declare Font
fopen "c:\smallsys.qbf", 1   '//Change this to directory u unzipped to

'//Declare PopUp
DIM SHARED Popup.Desktop$(1 TO 5)
Popup.Desktop$(1) = "Open"
Popup.Desktop$(2) = "Close"
Popup.Desktop$(3) = "Cut"
Popup.Desktop$(4) = "Copy"
Popup.Desktop$(5) = "Paste"
'//Mask for PopUp background
DIM SHARED mask(8000)

'//Declare Mouse
TYPE registers
   ax AS INTEGER
   bx AS INTEGER
   cx AS INTEGER
   dx AS INTEGER
   bp AS INTEGER
   si AS INTEGER
   di AS INTEGER
   flags AS INTEGER
   ds AS INTEGER
   es AS INTEGER
END TYPE
DIM SHARED mouse.button
DIM SHARED Mouse.x
DIM SHARED Mouse.y

'//Other Declarations
CONST true = 1  'Active
CONST False = 0 'InActive



'//Main Program
SCREEN 12
PAINT (1, 1), 7

CALL MouseDriver(0, 0, 0, 0)  '//Reset Mouse
CALL MouseDriver(1, 0, 0, 0)  '//Show Mouse

DO
	CALL MouseDriver(3, mouse.button, Mouse.x, Mouse.y)  '//Get Mouse Pos
	IF mouse.button = 2 THEN                            '//& Button Status
		CALL PopUp
	END IF
LOOP

SUB fopen (file$, file%)
  OPEN file$ FOR RANDOM AS file% LEN = 2
END SUB

SUB fprint (text$, textx%, texty%, colour%, file%)
  'lpi: lines per integer
  'fws: font word spacing
  'fls: font letter spacing
  'p% : pointer
  GET file%, 1, lpi%
  GET file%, 2, fws%
  GET file%, 3, fls%
  FOR count% = 1 TO LEN(text$)
	m% = ASC(MID$(text$, count%, 1)) - 29
	IF m% > 3 THEN
	  GET file%, m%, a1%
	  GET file%, m% + 1, a2%
	  FOR n% = a1% TO a2% - 1 STEP lpi%
		FOR z% = 0 TO lpi% - 1
		  GET file%, n% + z%, l%
		  LINE (p% + textx%, (16 * z%) + texty%)-(p% + textx%, (16 * z%) + 15 + texty%), colour%, , l%
		NEXT z%
		p% = p% + 1
	  NEXT n%
	  p% = p% + fls%
	ELSE
	  p% = p% + fws%
	END IF
  NEXT count%
END SUB

SUB MouseDriver (a, B, c, d)
DIM ms AS registers
ms.ax = a
ms.bx = B
ms.cx = c
ms.dx = d
CALL interrupt(51, ms, ms)
a = ms.ax
B = ms.bx
c = ms.cx
d = ms.dx

END SUB

SUB PopUp

Items = 5
xPopUp = 80                  '//PopUp Width
yPopUp = Items * 20 + 5      '//PopUp Length
xStart = Mouse.x
yStart = Mouse.y

CALL MouseDriver(2, 0, 0, 0)  '//Hide Mouse

'//The state of the mouse is an easy concept. If you dont understand the below
'//then go into Win95 and click in the middle, right, bottom and then
'//bottom-right corner of the screen, and see how the PopUp is drawn in
'//relation to the position of the cursor.

'//State 1, is when there is enough room to draw the PopUp so that
'//         the right and bottom edge do not draw off the screen
'//State 1 = xStart < 640-xPopUp and yStart < 480-yPopUp

'//State 2, is when the mouse is too close to the right side of the screen
'//         resulting in the PopUp being draw off screen,
'//         thus the PopUp is drawn towards the left
'//State 2 = xStart > 640-xPopUp and yStart < 480-yPopUp

'//State 3, is where the mouse is too close to the bottom of the screen
'//         resulting in the PopUp being drawn off screen,
'//         thus it is drawn towards the topof the screen.
'//State 3 = xStart < 640-xPopUp and yStart > 480-yPopUp

'//State 4, is where the mouse is too close to the right & bottom of the
'//         screen, thus the PopUp is drawn towards the left and top.
'//State 4 = xStart > 640-xPopUp and yStart > 480-yPopUp
 
'State 1
IF xStart < 640 - xPopUp AND yStart < 480 - yPopUp THEN
	State = 1
	GET (xStart, yStart)-(xStart + xPopUp, yStart + yPopUp), mask
	LINE (xStart, yStart)-(xStart + xPopUp, yStart + yPopUp), 7, BF
	LINE (xStart, yStart)-(xStart, yStart + yPopUp), 15
	LINE (xStart, yStart)-(xStart + xPopUp, yStart), 15
	LINE (xStart + xPopUp, yStart)-(xStart + xPopUp, yStart + yPopUp), 0
	LINE (xStart, yStart + yPopUp)-(xStart + xPopUp, yStart + yPopUp), 0
	FOR counter = 1 TO Items
	fprint Popup.Desktop$(counter), xStart + 5, yStart + ((counter * 20) - 17), 0, 1
	NEXT counter
END IF

'State 2
IF xStart > 640 - xPopUp AND yStart < 480 - yPopUp THEN
	State = 2
	GET (xStart, yStart)-(xStart - xPopUp, yStart + yPopUp), mask
	LINE (xStart, yStart)-(xStart - xPopUp, yStart + yPopUp), 7, BF
	LINE (xStart, yStart)-(xStart, yStart + yPopUp), 0
	LINE (xStart, yStart)-(xStart - xPopUp, yStart), 15
	LINE (xStart - xPopUp, yStart)-(xStart - xPopUp, yStart + yPopUp), 15
	LINE (xStart, yStart + yPopUp)-(xStart - xPopUp, yStart + yPopUp), 0
	FOR counter = 1 TO Items
	fprint Popup.Desktop$(counter), xStart - xPopUp + 5, yStart + ((counter * 20) - 17), 0, 1
	NEXT counter
END IF

'State 3
IF xStart < 640 - xPopUp AND yStart > 480 - yPopUp THEN
	State = 3
	GET (xStart, yStart)-(xStart + xPopUp, yStart - yPopUp), mask
	LINE (xStart, yStart)-(xStart + xPopUp, yStart - yPopUp), 7, BF
	LINE (xStart, yStart)-(xStart, yStart - yPopUp), 15
	LINE (xStart, yStart)-(xStart + xPopUp, yStart), 0
	LINE (xStart + xPopUp, yStart)-(xStart + xPopUp, yStart - yPopUp), 0
	LINE (xStart, yStart - yPopUp)-(xStart + xPopUp, yStart - yPopUp), 15
	FOR counter = 1 TO Items
	fprint Popup.Desktop$(counter), xStart + 5, yStart - yPopUp + ((counter * 20) - 17), 0, 1
	NEXT counter
END IF

'State 4
IF xStart > 640 - xPopUp AND yStart > 480 - yPopUp THEN
	State = 4
	GET (xStart, yStart)-(xStart - xPopUp, yStart - yPopUp), mask
	LINE (xStart, yStart)-(xStart - xPopUp, yStart - yPopUp), 7, BF
	LINE (xStart, yStart)-(xStart, yStart - yPopUp), 0
	LINE (xStart, yStart)-(xStart - xPopUp, yStart), 0
	LINE (xStart - xPopUp, yStart)-(xStart - xPopUp, yStart - yPopUp), 15
	LINE (xStart, yStart - yPopUp)-(xStart - xPopUp, yStart - yPopUp), 15
	FOR counter = 1 TO Items
	fprint Popup.Desktop$(counter), xStart - xPopUp + 5, yStart - yPopUp + ((counter * 20) - 17), 0, 1
	NEXT counter
END IF

CALL MouseDriver(1, 0, 0, 0)

WHILE mouse.button = 2
CALL MouseDriver(3, mouse.button, Mouse.x, Mouse.y)
WEND

DO

CALL MouseDriver(3, mouse.button, Mouse.x, Mouse.y)

FOR counter = 0 TO Items - 1
CALL MouseDriver(3, mouse.button, Mouse.x, Mouse.y)

SELECT CASE (State)
CASE IS = 1
IF Mouse.x > xStart AND Mouse.x < xStart + xPopUp AND Mouse.y > yStart + (counter * 20) AND Mouse.y < yStart + (counter * 20) + 22 THEN
	CALL MouseDriver(2, 0, 0, 0)
	LINE (xStart + 1, yStart + (counter * 20) + 2)-(xStart + xPopUp - 2, yStart + (counter * 20) + 22), 1, BF
	FOR Counter2 = 1 TO Items
		fprint Popup.Desktop$(Counter2), xStart + 5, yStart + ((Counter2 * 20) - 17), 0, 1
	NEXT Counter2
	CALL MouseDriver(1, 0, 0, 0)
  'Main Loop
	WHILE Mouse.x > xStart AND Mouse.x < xStart + xPopUp AND Mouse.y > yStart + (counter * 20) AND Mouse.y < yStart + (counter * 20) + 22
	CALL MouseDriver(3, mouse.button, Mouse.x, Mouse.y)
		IF mouse.button = 1 THEN
			CALL MouseDriver(2, 0, 0, 0)
			PUT (xStart, yStart), mask, PSET
			CALL MouseDriver(1, 0, 0, 0)
			GOTO actions:
		END IF
	WEND
	'Mouse has moved so redraw last item
	CALL MouseDriver(2, 0, 0, 0)
	LINE (xStart + 1, yStart + (counter * 20) + 2)-(xStart + xPopUp - 2, yStart + (counter * 20) + 22), 7, BF
	FOR Counter2 = 1 TO Items
		fprint Popup.Desktop$(Counter2), xStart + 5, yStart + ((Counter2 * 20) - 17), 0, 1
	NEXT Counter2
	CALL MouseDriver(1, 0, 0, 0)
ELSE
	IF mouse.button = 1 THEN
		CALL MouseDriver(2, 0, 0, 0)
		PUT (xStart, yStart), mask, PSET
		CALL MouseDriver(1, 0, 0, 0)
		EXIT SUB
	END IF
END IF

CASE IS = 2

IF Mouse.x > xStart - xPopUp AND Mouse.x < xStart AND Mouse.y > yStart + (counter * 20) AND Mouse.y < yStart + (counter * 20) + 22 THEN
	CALL MouseDriver(2, 0, 0, 0)
	LINE (xStart - xPopUp + 1, yStart + (counter * 20) + 2)-(xStart - 2, yStart + (counter * 20) + 22), 1, BF
	FOR Counter2 = 1 TO Items
		fprint Popup.Desktop$(Counter2), xStart - xPopUp + 5, yStart + ((Counter2 * 20) - 17), 0, 1
	NEXT Counter2
	CALL MouseDriver(1, 0, 0, 0)
  'Main Loop
	WHILE Mouse.x > xStart - xPopUp AND Mouse.x < xStart AND Mouse.y > yStart + (counter * 20) AND Mouse.y < yStart + (counter * 20) + 22
	CALL MouseDriver(3, mouse.button, Mouse.x, Mouse.y)
	IF mouse.button = 1 THEN
		CALL MouseDriver(2, 0, 0, 0)
		PUT (xStart - xPopUp, yStart), mask, PSET
		CALL MouseDriver(1, 0, 0, 0)
		GOTO actions:
	END IF
	WEND
	'Mouse has moved so redraw last item
	CALL MouseDriver(2, 0, 0, 0)
	LINE (xStart - xPopUp + 1, yStart + (counter * 20) + 2)-(xStart - 2, yStart + (counter * 20) + 22), 7, BF
	FOR Counter2 = 1 TO Items
		fprint Popup.Desktop$(Counter2), xStart - xPopUp + 5, yStart + ((Counter2 * 20) - 17), 0, 1
	NEXT Counter2
	CALL MouseDriver(1, 0, 0, 0)
ELSE
	IF mouse.button = 1 THEN
		CALL MouseDriver(2, 0, 0, 0)
		PUT (xStart - xPopUp, yStart), mask, PSET
		CALL MouseDriver(1, 0, 0, 0)
		EXIT SUB
	END IF
END IF

CASE IS = 3

IF Mouse.x > xStart AND Mouse.x < xStart + xPopUp AND Mouse.y > yStart - yPopUp + (counter * 20) AND Mouse.y < yStart - yPopUp + (counter * 20) + 22 THEN
	CALL MouseDriver(2, 0, 0, 0)
	LINE (xStart + 1, yStart - yPopUp + (counter * 20) + 2)-(xStart + xPopUp - 2, yStart - yPopUp + (counter * 20) + 22), 1, BF
	FOR Counter2 = 1 TO Items
		fprint Popup.Desktop$(Counter2), xStart + 5, yStart - yPopUp + ((Counter2 * 20) - 17), 0, 1
	NEXT Counter2
	CALL MouseDriver(1, 0, 0, 0)
  'Main Loop
	WHILE Mouse.x > xStart AND Mouse.x < xStart + xPopUp AND Mouse.y > yStart - yPopUp + (counter * 20) AND Mouse.y < yStart - yPopUp + (counter * 20) + 22
	CALL MouseDriver(3, mouse.button, Mouse.x, Mouse.y)
		IF mouse.button = 1 THEN
			CALL MouseDriver(2, 0, 0, 0)
			PUT (xStart, yStart - yPopUp), mask, PSET
			CALL MouseDriver(1, 0, 0, 0)
			GOTO actions:
		END IF
	WEND
	'Mouse has moved so redraw last item
	CALL MouseDriver(2, 0, 0, 0)
	LINE (xStart + 1, yStart - yPopUp + (counter * 20) + 2)-(xStart + xPopUp - 2, yStart - yPopUp + (counter * 20) + 22), 7, BF
	FOR Counter2 = 1 TO Items
		fprint Popup.Desktop$(Counter2), xStart + 5, yStart - yPopUp + ((Counter2 * 20) - 17), 0, 1
	NEXT Counter2
	CALL MouseDriver(1, 0, 0, 0)
ELSE
	IF mouse.button = 1 THEN
		CALL MouseDriver(2, 0, 0, 0)
		PUT (xStart, yStart - yPopUp), mask, PSET
		CALL MouseDriver(1, 0, 0, 0)
		EXIT SUB
	END IF
END IF

CASE IS = 4
IF Mouse.x > xStart - xPopUp AND Mouse.x < xStart AND Mouse.y > yStart - yPopUp + (counter * 20) AND Mouse.y < yStart - yPopUp + (counter * 20) + 22 THEN
	CALL MouseDriver(2, 0, 0, 0)
	LINE (xStart - xPopUp + 1, yStart - yPopUp + (counter * 20) + 2)-(xStart - 2, yStart - yPopUp + (counter * 20) + 22), 1, BF
	FOR Counter2 = 1 TO Items
		fprint Popup.Desktop$(Counter2), xStart - xPopUp + 5, yStart - yPopUp + ((Counter2 * 20) - 17), 0, 1
	NEXT Counter2
	CALL MouseDriver(1, 0, 0, 0)
  'Main Loop
	WHILE Mouse.x > xStart - xPopUp AND Mouse.x < xStart AND Mouse.y > yStart - yPopUp + (counter * 20) AND Mouse.y < yStart - yPopUp + (counter * 20) + 22
	CALL MouseDriver(3, mouse.button, Mouse.x, Mouse.y)
		IF mouse.button = 1 THEN
			CALL MouseDriver(2, 0, 0, 0)
			PUT (xStart - xPopUp, yStart - yPopUp), mask, PSET
			CALL MouseDriver(1, 0, 0, 0)
			GOTO actions:
		END IF
	WEND
	'Mouse has moved so redraw last item
	CALL MouseDriver(2, 0, 0, 0)
	LINE (xStart - xPopUp + 1, yStart - yPopUp + (counter * 20) + 2)-(xStart - 2, yStart - yPopUp + (counter * 20) + 22), 7, BF
	FOR Counter2 = 1 TO Items
		fprint Popup.Desktop$(Counter2), xStart - xPopUp + 5, yStart - yPopUp + ((Counter2 * 20) - 17), 0, 1
	NEXT Counter2
	CALL MouseDriver(1, 0, 0, 0)
ELSE
	IF mouse.button = 1 THEN
		CALL MouseDriver(2, 0, 0, 0)
		PUT (xStart - xPopUp, yStart - yPopUp), mask, PSET
		CALL MouseDriver(1, 0, 0, 0)
		EXIT SUB
	END IF
END IF

END SELECT




actions:
LOCATE 1, 10: PRINT STR$(counter + 1) + " Item Clicked"
END SUB

